﻿//引用http和socket.io模块
var us = {}//自己定义的命名空间
us.http = require('http'), socketio = require('socket.io');
//开始http服务
us.app = us.http.createServer(function (req, res) { });
//服务开始监听
us.app.listen(888);
//输出调试信息
//console.log("Http Server start at 888");

//socketio开始监听
us.socketio = socketio.listen(us.app);
//socketio等待连接
us.socketio.sockets.on('connection', function (socket) {
    console.log('connected...');//日志信息
    //获取所有客户端发送来的位置信息
    socket.on('cPosition', function (data) {
        //把位置信息广播给所有客户端。注意：bPosition，cPosition和前台的对应关系。
        socket.broadcast.emit('bPosition', data);
    });
});